#include "strstr.h"

/*
  checkPatJIS : JISɥѥν

  string& pattern : оݤΥѥʸ

   : ѥƬʸ
*/
JIS_CODE checkPatJIS( string& pattern )
{
  if ( pattern.length() == 0 ) return( JIS_ASCII );

  JIS_CODE jisCode = JIS_ASCII; // ѥƬʸ ASCII ʸǽ
  switch ( pattern[0] ) {
  case ESC: // ƬESCξ
    if ( strncmp_( pattern.begin(), HANKANA, sizeof(HANKANA) - 1 ) == 0 )
      jisCode = JIS_HANKANA; // Ⱦѥ
    else if ( strncmp_( pattern.begin(), ASCII, sizeof(ASCII) - 1 ) != 0 &&
              strncmp_( pattern.begin(), ROMAN, sizeof(ROMAN) - 1 ) != 0 )
      jisCode = JIS_2BYTE; // Хʸ
    // ƬΥס󥹤Ͻ
    pattern = pattern.substr( ESCSEQ_LEN );
    break;
  case SI:  // ƬSI,SOξ硢ʸ
  case SO:
    if ( pattern[0] == SO ) jisCode = JIS_HANKANA; // SOǻϤޤȾѥ
    pattern = pattern.substr( 1 );
    break;
  }

  if ( pattern.length() > 0 ) {
    if ( pattern.length() >= ESCSEQ_LEN && pattern[pattern.length() - ESCSEQ_LEN] == ESC ) {
      // ץ󥹤ξν
      pattern = pattern.substr( 0, pattern.length() - ESCSEQ_LEN );
    } else {
      // SI,SOξν
      char c = pattern[pattern.length() - 1];
      if ( c == SI || c == SO )
        pattern = pattern.substr( 0, pattern.length() - 1 );
    }
  }

  return( jisCode );
}

/*
  makeBMTable : ե(bmTable)κ

  const string& pattern : оݤʸ
  map<char,string::size_type>& bmTable : ư̤ݻ
*/
void makeBMTable( const string& pattern, map<char,string::size_type>& bmTable )
{
  string::const_iterator patIt = pattern.begin(); // pattern Фȿ
  string::size_type counter = pattern.length();   // 

  bmTable.clear();

  while ( counter > 0 )
    bmTable[*patIt++] = --counter;
}

/*
  bmStrstr : BMˡˤʸȹ

  const string& text : ʸ
  const string& pattern : оݤʸ
  string::size_type txtIdx : ϰ
  KANJI_CODE code : 

   : פ( npos ʤиĤʤä)
*/
string::size_type bmStrstr( string& text, string pattern,
                            string::size_type txtIdx, KANJI_CODE code )
{
  /* JISɤξ */
  JIS_CODE jisCode; // ѥƬʸФʸ
  if ( code == KANJI_JIS )
    jisCode = checkPatJIS( pattern );

  string::size_type patLen = pattern.length(); // pattern ʸĹ
  string::size_type txtLen = text.length();    // text ʸĹ

  if ( txtLen < patLen ) return( string::npos );
  txtLen -= patLen;

  // ԰׻Υѥΰư̤
  map<char,string::size_type> bmTable;
  makeBMTable( pattern, bmTable );

  while ( txtIdx <= txtLen ) {
    string::size_type patIdx = patLen; // Ӱ
    for ( ; patIdx > 0 ; --patIdx )
      if ( text[txtIdx + patIdx - 1] != pattern[patIdx - 1] )
        break;

    if ( patIdx == 0 ) { // ưפ!!
      bool b = true;
      switch ( code ) {
      case KANJI_EUCJP:
        b = checkEUC( text.begin(), text.begin() + txtIdx );
        break;
      case KANJI_SJIS:
        b = checkSJIS( text.begin(), text.begin() + txtIdx );
        break;
      case KANJI_JIS:
        b = checkJIS( text.begin(), text.begin() + txtIdx, jisCode );
      }
      if ( b ) return( txtIdx );
      ++txtIdx; // ̵ǰʸʤ(̵¥롼ײ)
      continue;
    }

    // ơ֥뤫ư̤
    map<char,string::size_type>::const_iterator mapIt = // bmTableϿ
      bmTable.find( text[txtIdx + patIdx - 1] );
    string::size_type shtIdx = patIdx; // ư(԰ȯ֤ǽ)
    if ( mapIt != bmTable.end() ) {
      string::size_type i1 = mapIt->second;   // Ȥư
      string::size_type i2 = patLen - patIdx; // (԰ʸκʬ)
      shtIdx = ( i1 < i2 ) ? 2 : i1 - i2;
    }
    txtIdx += shtIdx;
  }

  return( string::npos );
}


