#include "strstr.h"

/*
   checkEUC : ȹ֥å롼(EUC)

   string::const_iterator i0 : ʸƬ
   string::const_iterator i1 : ȹ

    true ...  ; false ... ʤ
*/
bool checkEUC( string::const_iterator i0, string::const_iterator i1 )
{
  string::const_iterator i = i1;
  for ( ; i > i0 ; --i )
    if ( *( i - 1 ) > 0 ) break;

  return( ( i1 - i ) % 2 == 0 );
}

/*
   checkSJIS : ȹ֥å롼(SJIS)

   string::const_iterator i0 : ʸƬ
   string::const_iterator i1 : ȹ

    true ...  ; false ... ʤ
*/
bool checkSJIS( string::const_iterator i0, string::const_iterator i1 )
{
  string::const_iterator i = i1;

  for ( ; i > i0 ; --i ) {
    unsigned char c = *( i - 1 );
    if ( ( c < 0x81 ) || ( c > 0x9F && c < 0xE0 ) || ( c > 0xEF ) )
      break;
  }

  return( ( i1 - i ) % 2 == 0 );
}

/*
   ȹ֥å롼(JIS)

   string::const_iterator i0 : ʸƬ
   string::const_iterator i1 : ȹ
   JIS_CODE jisCode : ѥƬʸФʸ

    true ...  ; false ... ʤ
*/
bool checkJIS( string::const_iterator i0, string::const_iterator i1, JIS_CODE jisCode )
{
  string::const_iterator i = i1; // ʸ(ȹ֤ǽ)

  for ( ; i > i0 ; --i ) {
    switch ( *( i - 1 ) ) {
    case ESC : // ESCĤä!!
      if ( i1 - i + 1 <= 2 ) return( false ); // Ƭ ESC_SEQ 
      if ( jisCode == JIS_ASCII ) {
        // ASCII,޻ǻϤޤ硢ASCIIJIS޻ESC_SEQʤOK
        return(
               ( strncmp_( i - 1, ASCII, sizeof(ASCII) - 1 ) == 0 ) || // ASCII  ESC_SEQ
               ( strncmp_( i - 1, ROMAN, sizeof(ROMAN) - 1 ) == 0 )    // JIS޻ ESC_SEQ
               );
      } else if ( jisCode == JIS_HANKANA ) {
        // ȾѥʤǻϤޤ硢ȾѥʤESC_SEQʤOK
        return( strncmp_( i - 1, HANKANA, sizeof(HANKANA) - 1 ) == 0 );
      } else {
        // /JISǻϤޤ
        if ( ( strncmp_( i - 1, NEWJIS, sizeof(NEWJIS) - 1 ) != 0 ) && // JIS ESC_SEQ Ǥʤ
             ( strncmp_( i - 1, OLDJIS, sizeof(OLDJIS) - 1 ) != 0 ) )  // JIS ESC_SEQ Ǥʤ
          return( false );
        else
          return( ( i1 - i ) % 2 == 0 ); // JISʤʸǧ
      }
      break;
    case SO : // SOĤä!!
      // ѥȾѥʤǻϤޤʤפȤߤʤ
      return( jisCode == JIS_HANKANA );
    }
  }
  /*
    ץ󥹤Ĥʤ
    ѥʸ礬ASCII޻ǻϤޤʤ true
  */
  return( jisCode == JIS_ASCII );
}
