/*
  ʸȹ ץ롦ץ 2013-11-10
*/

#include "strstr.h"

// iconvѴѥ᡼
const string ICONV_NAME[] = {
  "ISO-2022-JP-2",
  "SHIFT-JIS",
  "EUC-JP",
  "UTF-8",
};

// Codeѥѥ᡼
const char CODE_OPTION[] = {
  'j', 's', 'e', 'u',
};

// ץꥹ
OptStruct OptList[] = {
  OptStruct( "-p", 'p', "-pX ... specify pattern code (X=j,s,e,u)" ),
  OptStruct( "-t", 't', "-tX ... specify text code (X=j,s,e,u)" ),
  OptStruct( "-x", 'x', "-x  ... regard pattern as HEX code" ),
  OptStruct( "-h", 'h', "-h  ... HELP" ),
  OptStruct( "", '\0', "" ),
};

KANJI_CODE PatCode = KANJI_NOCARE; // ѥ
KANJI_CODE TxtCode = KANJI_NOCARE; // ƥȴ
bool HexFlag = false; // HEXɤѴɬפ뤫

/*
  help : إפν

  const string& prgName : ץ̾
  OptStruct* optList : ץꥹ
*/
void help( const string& prgName, OptStruct* optList )
{
  cerr << "Usage : " << prgName << " [-option] pattern [file]" << endl;
  for ( ; optList->index != '\0' ; ++optList )
    cerr << "\t" << optList->message << endl;

  cerr << endl << "Available kanji code :" << endl;
  for ( unsigned int i = 0 ; i < KANJI_NOCARE ; ++i )
    fprintf( stderr, "\t%s (option -p%c, -t%c)\n", ICONV_NAME[i].c_str(), CODE_OPTION[i], CODE_OPTION[i] );
}

/*
  getCode : ɤμ

  char c : Codeѥѥ᡼
  KANJI_CODE& code : ɼѿ

   : true ...  ; false ... 
*/
bool getCode( char c, KANJI_CODE& code )
{
  switch ( c ) {
  case 'e': // EUC
    code = KANJI_EUCJP;
    break;
  case 'j': // JIS
    code = KANJI_JIS;
    break;
  case 's': // SJIS
    code = KANJI_SJIS;
    break;
  case 'u': // UTF-8
    code = KANJI_UTF8;
    break;
  default:
    fprintf( stderr, "ERROR : Invalid pattern code [%c]\n", c );
    return( false );
  }

  return( true );
}

/*
  getCode : ץμ

  const string& prgName : ץ̾
  char* argv : ץ

   : true ...  ; false ... 
*/
bool getOption( const string& prgName, char* argv )
{
  OptStruct* optIdx;
  for ( optIdx = OptList ; optIdx->index != '\0' ; ++optIdx )
    if ( strncmp( argv, ( optIdx->flag ).c_str(), ( optIdx->flag ).length() ) == 0 )
      break;

  switch ( optIdx->index ) {
  case 'p': // ѥδɻ
    if ( strlen( argv ) < 3 ) {
      cerr << "ERROR : Pattern code not specified after option -p" << endl;
      return( false );
    }
    return ( getCode( argv[2], PatCode ) );
  case 't': // ƥȤδɻ
    if ( strlen( argv ) < 3 ) {
      cerr << "ERROR : Text code not specified after option -t" << endl;
      return( false );
    }
    return ( getCode( argv[2], TxtCode ) );
  case 'x': // ѥHEX CODEȤư
    HexFlag = true;
    return( true );
  case 'h': // HELP
    help( prgName, OptList );
    return( false );
  }
  cerr << "ERROR : Invalid option [" << argv << "]" << endl;
  return( false );
}

/*
  a2Hex : 16ʿɽʸͤѴ

  string& pattern : оݤʸ

   : true ... Ѵ ; false ... Ѵ
*/
bool a2Hex( string& pattern )
{
  pattern = "";

  for ( string::const_iterator it = pattern.begin() ; it != pattern.end() ; ) {
    char c0 = toupper( *it++ ); // ̤ο
    if ( it == pattern.end() ) {
      cerr << "ERROR : When using -x option, pattern length must be even." << endl;
      return( false );
    }
    char c1 = toupper( *it++ ); // ̤ο
    if ( isxdigit( c0 ) == 0 || isxdigit( c1 ) == 0 ) {
      fprintf( stderr, "ERROR : Invalid character [%c%c].\n", c0, c1 );
      return( false );
    }
    pattern += (char)( a2Hex( c0 ) * 0x10 + a2Hex( c1 ) );
  }

  return( true );
}

/*
  checkArg : Υå

  unsigned int argc : θĿ(ץ̾ޤ)
  char* argv[] : ꥹ
  string& pattern : ѥʸѿ
  string& fileName : ե̾ѿ

   : true ... åPass ; false ... åFail
*/
bool checkArg( unsigned int argc, char* argv[], string& pattern, string& fileName )
{
  string prgName = argv[0]; // ץ̾

  for ( unsigned int i = 1 ; i < argc ; i++ ) {
    if ( argv[i][0] == '-' ) {
      if ( ! getOption( prgName, argv[i] ) )
	return( false );
    } else if ( pattern.length() == 0 ) { // ץʳΰܤΰϥѥʸ
      pattern = argv[i];
    } else if ( fileName.length() == 0 ) { // ץʳܤΰϥե̾
      fileName = argv[i];
    } else {
      cerr << "ERROR : Too many parameters." << endl;
      return( false );
    }
  }

  if ( pattern.length() == 0 ) {
    cerr << "ERROR : Pattern is not specified." << endl;
    return( false );
  }
  if ( HexFlag )
    return( a2Hex( pattern ) );

  return( true );
}

/*
  kanjiConv : iconvȤäƥѥʸΥѴԤ

  string& pattern : ѥʸ

   : true ... Ѵ ; false ... Ѵ
*/
bool kanjiConv( string& pattern )
{
  if ( HexFlag ) return( true ); // 16ɽξϲ⤷ʤ

  char buffer[1024];   // ѴʸϿѥХåե
  char* bufP = buffer; // ХåեؤΥݥ
  size_t srcLen = pattern.length();   // ѥʸĹ
  size_t bufLen = sizeof(buffer) - 1; // ХåեΥ

  // ѥʸ char* Ѵ
  char* src = new char[srcLen + 1];
  pattern.copy( src, string::npos );
  src[srcLen] = '\0';
  char* srcP = src; // ѴѥʸؤΥݥ

  // iconv 
  iconv_t ic = iconv_open( ICONV_NAME[TxtCode].c_str(), ICONV_NAME[PatCode].c_str() );
  if ( ic == (iconv_t)-1 ) {
    cerr << "Failed to open iconv : From=" << ICONV_NAME[PatCode] << " To=" << ICONV_NAME[TxtCode] << endl;
    delete[] src;
    return( false );
  }

  // ѥѴ
  bufLen = iconv( ic, &srcP, &srcLen, &bufP, &bufLen );
  if ( bufLen < 0 ) {
    cerr << "Failed to convert from=" << ICONV_NAME[PatCode] << " to " << ICONV_NAME[TxtCode] << endl;
    if ( errno == E2BIG )
      cerr << "There is not sufficient room at buffer." << endl;
    else if ( errno == EILSEQ )
      cerr << "An invalid multibyte sequence has been encountered in the input." << endl;
    else if ( errno == EINVAL )
      cerr << "An incomplete multibyte sequence has been encountered in the input." << endl;
    else
      cerr << "errno = " << errno << endl;
  }
  *bufP = '\0';
  iconv_close( ic );

  if ( bufLen >= 0 )
    pattern = buffer;

  delete[] src;

  return( bufLen >= 0 );
}

/*
  main : ᥤ󡦥롼

  int argc : ο(ץ̾ޤ)
  char* argv[] : ꥹ

   : >=0 ... פԿ ; <0 ... 
*/
int main( int argc, char* argv[] )
{
  string text;        // ƥʸ
  string pattern;     // ѥʸ
  string fileName;    // ϥե̾
  istream* is = &cin; // ϥȥ꡼(ɸϤǽ)

  // å
  if ( ! checkArg( argc, argv, pattern, fileName ) )
    return( -1 );

  // Ѵ
  if ( PatCode != KANJI_NOCARE && TxtCode != KANJI_NOCARE )
    if ( ! kanjiConv( pattern ) )
      return( -1 );

  // ե뤬ꤵƤϥȥ꡼
  if ( fileName.length() > 0 ) {
    is = new ifstream( fileName.c_str() );
    if ( ! *is ) {
      fprintf( stderr, "ERROR : Cannot open [%s].\n", fileName.c_str() );
      return( -1 );
    }
  }

  // ʸȹ
  unsigned int ans = 0;
  while ( *is && getline( *is, text ) ) {
    if ( bmStrstr( text, pattern, 0, TxtCode ) != string::npos ) {
      ++ans;
      cout << text << endl;
    }
  }

  return( ans );
}
