#ifndef _STRSTR_H
#define _STRSTR_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <iconv.h>
#include <errno.h>

#include <vector>
#include <algorithm>
#include <functional>
#include <string>
#include <iostream>
#include <fstream>
#include <limits>
#include <map>

using std::iterator_traits;
using std::basic_string;
using std::string;

using std::vector;
using std::map;

using std::istream;
using std::ifstream;
using std::cin;
using std::cout;
using std::cerr;
using std::endl;

// 
enum KANJI_CODE {
  KANJI_JIS = 0,
  KANJI_SJIS = 1,
  KANJI_EUCJP = 2,
  KANJI_UTF8 = 3,
  KANJI_NOCARE = 4,
};

// JISȽ̥
enum JIS_CODE {
  JIS_ASCII = 0,   // ASCII, ޻
  JIS_2BYTE = 1,   // JIS
  JIS_HANKANA = 2, // Ⱦѥ
};

const char ESC = 0x1B; // Escape
const char SI = 0x0F;  // Shift In
const char SO = 0x0E;  // Shift Out

// ס
const char ASCII[] = "\x1B(B";  // ASCII
const char ROMAN[] = "\x1B(J";  // JIS X 0201޻
const char NEWJIS[] = "\x1B$B"; // JIS X 0208-1983 (JIS)
const char OLDJIS[] = "\x1B$@"; // JIS X 0208-1978 (JIS)
const char HANKANA[] = "\x1B(I"; // Ⱦѥ
const string::size_type ESCSEQ_LEN = 3; // ס󥹤Ĺ

// 16ʿͤѴ
inline char a2Hex( char c ) {
  return( ( c <= '9' ) ? c - '0' : c - 'A' + 10 );
}

// ץѹ¤
struct OptStruct {
  string flag;    // ץʸ
  char index;     // ̻
  string message; // å

  // 󥹥ȥ饯
  OptStruct( const string& flag_, char index_, const string& message_ )
  : flag( flag_ ), index(index_ ), message( message_ ) {}
};

/*
  strncmp_ : ĤʸꤷĹʬӤ

  In1 s1, In2 s2 : ĤʸƬݥ
  unsigned int len : ӤʸĹ

  üʸΥåϹԤʤ
  ʸʤʸĤä顢κʬ֤

   : <0 ... s1 ; >0 ... s1礭
          =0 ... s1s2
*/
template<class In1, class In2>
int strncmp_( In1 s1, In2 s2, unsigned int len )
{
  int cmpret = 0; // ʸӷ

  for ( unsigned int i = 0 ; i < len ; i++ ) {
    if ( ( cmpret = *s1 - *s2 ) != 0 )
      break;
    ++s1; ++s2;
  }

  return( cmpret );
}

string::size_type bmStrstr( string& text, string pattern,
                            string::size_type txtIdx, KANJI_CODE code );

bool checkEUC( string::const_iterator i0, string::const_iterator i1 );
bool checkSJIS( string::const_iterator i0, string::const_iterator i1 );
bool checkJIS( string::const_iterator i0, string::const_iterator i1, JIS_CODE jisCode );

#endif
